#!/home/easybuild/.local/easybuild/software/Python/3.7.0-foss-2018b/bin/python3

import glob
import os
import os.path as op
import subprocess as sp
import sys

DEMO_FILE = "/home/ulg/crc/mgrgnrd/giga_doctoral_school/.demo"
ORIGIN = "/home/ulg/crc/mgrgnrd/giga_doctoral_school"

cmds = [
	"ls -a",
	"cat helloworld.sh",
	"cat helloworld_submit.sh",
	"sbatch helloworld_submit.sh",
	"ls -a",
	"for f in *.helloworld; do cat ${f}; echo ''; done",
	"ls -a",
	"cat rawdata_0.in",
	"cat preproc.sh",
	"cat preproc_submit.sh",
	"sbatch preproc_submit.sh",
	"ls -a",
	"for f in *.preproc; do cat ${f}; echo ''; done",
	"cat rawdata_0.in; echo ''; cat preprocdata_0.out",
	"ls -a",
	"cat rawdata_0.in",
	"cat workflow_submit.sh",
	"cat workflow.sh",
	"sbatch workflow_submit.sh",
	"ls -a",
	"for f in *.workflow; do cat ${f}; echo ''; done",
	"cat rawdata_0.in; echo ''; cat preprocdata_0.out",
	"squeue --help",
	"squeue -u $USER",
	"sstat -j 1756368",
	"sacct -j 1756368 -o User,JobID,Jobname,state,elapsed,MaxRSS",
	"sinfo"
	]

def clean_dir(directory, patterns):
	for p in patterns:
		for f in glob.glob(op.join(directory, p)):
			os.remove(op.join(f))

def set_cmd_index(new_index):
	if new_index == -1:
		new_index = get_cmd_index() - 1
	with open(DEMO_FILE, "w") as f:
		f.write(str(new_index))
	if new_index == 0:
		sp.run("clear")
		clean_dir("helloworld", ["*.helloworld"])
		clean_dir("preproc", ["*.out", "*.preproc"])
		clean_dir("workflow", ["*.out", "*.workflow"])

def get_cmd_index():
	with open(DEMO_FILE, "r") as f:
		index = int(f.read())
	return index

def print_read_eval(directory, cmd):
	up = "\x1b[1A"
	erase = "\x1b[2K"
	color = "\x1b[96m"
	no_color = "\x1b[0m"
	print(up + erase + "(" + directory + ") $ " + color + cmd.split()[0] + no_color + " " +  " ".join(cmd.split()[1:]) + "\n")
	sp.run(cmd, shell=True, check=True)
	print("\n")

if __name__ == "__main__":
	if len(sys.argv) > 1:
		set_cmd_index(int(sys.argv[1]))

	else:
		cmd_index = get_cmd_index()
		
		# Set directory
		if cmd_index < 6:
			directory = "helloworld"
			full_directory = op.join(ORIGIN, directory)
		elif cmd_index < 14:
			directory = "preproc"
			full_directory = op.join(ORIGIN, directory)
		elif cmd_index < 22:
			directory = "workflow"
			full_directory = op.join(ORIGIN, directory)
		else:
			directory = "course"
			full_directory = ORIGIN
		os.chdir(full_directory)
		
		# Run the command
		if cmd_index <= len(cmds):
			print_read_eval(directory, cmds[cmd_index])
			set_cmd_index(cmd_index + 1)
		
