#!/bin/bash

CURRENTDIR=${PWD}

# Copying data to $GLOBALSCRATCH
echo "Copying raw data to globalscratch."
TMPDIR=${GLOBALSCRATCH}/${SLURM_JOB_ID}/${2}
mkdir ${TMPDIR}
cp ${1} ${TMPDIR}/rawdata.in

# Moving to the global directory
echo "Moving to globalscratch."
cd ${TMPDIR}

# Preprocessing the file
echo "Preprocessing file..."
OUTFILE="${TMPDIR}/preprocdata_${2}.out"
cat ${TMPDIR}/rawdata.in | tr "[a-z]" . > ${OUTFILE}
echo "Result written."

# Copying the result to $HOME
echo "Copying result to home."
cp ${OUTFILE} ${CURRENTDIR}

# Moving back to the home directory
echo "Moving to home."
cd ${CURRENTDIR}

# Cleaning the temporary directory
echo "Cleaning the globalscratch."
rm -rf ${TMPDIR}

echo "Done."
